// skies.wdl         A. Serdar Kucuk aserdarkucuk@yahoo.com
// Mountains and clouds for nighttime may also be added.




var video_mode = 7; // 800 pixels
var video_depth = 32; // 32 bit mode
var stand_percentage;

entity* guard;
//////////////////////////////////////////////////////////////////////////

string skies_wmb = <skies.wmb>; 

/////////////////////////////////////////////////////////
// The following script controls the night sky with stars, this is the outmost layer.



sky cubesky
{
	type=<skycube+6.pcx>;
	layer=1;
	material = mat_sky;
	z = 30;
	flags = cube, visible ;
  
}

//////////////////////////////////////////////////////////////////////////
// This is the next layer just inside.
// Alpha value of this layer will be changed through a function to fade in/out into the night sky.



sky cubeskyday
{
	type=<skycubeday+6.tga>;
	layer=2;
	material = mat_sky;
	z = 50;
	alpha=0;
	flags = cube, transparent, visible;	
        
}

///////////////////////////////////////////////////////////////////////
// This is a sun picture, which will move through a function, between the day sky and the mountains.



 sky sun
{
	type=<sun.tga>;
	layer=3;
	x=200;
	y=0;
	z=0;	
	material = mat_sky;
	flags =  visible;

}


////////////////////////////////////////////////////////////////////


sky  cloud
{
        type = <cloud.tga>; 
 	layer = 4;	
	scale_x = 2;
	speed_u = 50; 
	speed_v = 10;
 	flags = dome, transparent,   visible;	
	alpha = 100;

} 


/////////////////////////////////////////////////////////////////////
// This picture titled "Grand Taton" is used with the permission of M. Giuli Hurtado.

sky mount
{
	type=<mountcube+6.tga>;
	layer=5;	
	material = mat_sky;	
	flags = cube, visible;
}

////////////////////////////////////////////////////////////////////////////

action guardstand
{   
  guard = me; 	
    while (1) 
    { 
       ent_animate(my, "stand", stand_percentage, anm_cycle); // "stand" animation loop
       stand_percentage += 3 * time; // 3 = animation speed for "stand"
       wait (1); 
    } 
} 

//////////////////////////////////////////////////////////////////////////



function sunmove()
{
while(1)
{
	while(sun.x > 0)
	{
	sun.x -= 1 * time;
	sun.z += 1 * time;
	wait(1);
	}

	while((sun.x < 0) && (sun.x > -200))
	{
	sun.x -= 1 * time;
	sun.z -= 1 * time;
	wait(1);
	}


wait(1);
}
}

////////////////////////////////////////////////////////////////////////////////
// This function will change sun direction and thus shadows . Also will smoothly change the day and night.


function lightmove()
{
  while(1)
  {
	while (guard == NULL) { wait(1); } // wait until there is a guard.
	

	while(sun_angle.tilt < 80)
	{
        if (sun_angle.tilt > 13)	{  guard.shadow = on;  }
        sun_angle.tilt += 0.4 * time;	                // This controls sunrise.
 			if (cubeskyday.alpha < 97) 
   			{  
     			cubeskyday.alpha += 2*time;     // Fade out the layer of day sky.
   			}
 	wait(1);
	}

	sun_angle.pan = 180;                     // After sunrise finishes change the direction to right back of the model; Gives better result.






	while(sun_angle.tilt > -2)
	{
        if (sun_angle.tilt < 8)	{  guard.shadow = off;  }
        sun_angle.tilt -= 0.4 * time;	                // This controls sunset.
   			if (cubeskyday.alpha > 3) && (sun_angle.tilt < 25)
   			{  
     			cubeskyday.alpha -= 2*time; 
   			}
	wait(1);
	}
		
	sun_angle.pan = 0;

			sun.x=200;
			sun.y=0;
			sun.z=0;
    wait(1);
  }
} 





///////////////////////////////////////////////////////////////////////////////


function main()
{
	level_load (skies_wmb);
	wait (5); // wait until the level is loaded 
	camera.arc = 75;
	sky_curve=3;                // Steepness of clouds; very flat.         
 	sky_clip = -90;             // Show the whole cloud sphere. The lower part will be seen through an alpha hole on the terrain, which will give the effect of a lake. 
	sunmove();
	lightmove();
	
  	   while (1)                // Free look with mouse.
  	   {        
   		  camera.pan -= mouse_force.x*4; 
        	  camera.tilt += mouse_force.y*4;  
     	  	  wait (1); 
     	   } 

}



